// C Source File
// Created 10/19/2000; 4:55:18 PM

// Available Patches
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#define fatal(s) {ST_showHelp(s);return;}

#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File

//definitions
void endevent(void);
volatile void eventhook(EVENT *ev);

// Main Function
void _main(void)
{
	long eventsize;
	HANDLE eventhandle;
	void *mempnt;
	//allocation of memory
	eventsize=(char *)endevent-(char *)eventhook;
	eventhandle=HeapAllocHigh(eventsize+20);
	//set-up of event hooik.......
	if (!eventhandle)
		fatal("Not enough Memory!");
	mempnt=HeapDeref(HeapLock(eventhandle));
	mempnt += 0x40000; // for HW2
	strcpy(mempnt, "evHkOnKeyExp"); // the signature, change to match your prog..........
	mempnt += 12; // skip the string
	*( (DWORD *) mempnt) = (DWORD) EV_hook; // address of the old event hook
	mempnt += 4; // skip the address
	memcpy(mempnt, eventhook, eventsize); // copy the hook over
	EV_hook = mempnt; // might need a cast here
	fatal("OnKeyExpress by Dave Watson Installed!");//change to match your prog name.........
}

volatile void eventhook(EVENT *ev)
{
	void (*fnc)(EVENT *);
	void *mempnt;
	//insert your routines here................
	
	if (ev->Type == CM_KEYPRESS)
    {
      if (ev->extra.Key.Code == KEY_ON)
        asm("trap #4");//ev->extra.Key.Code = KEY_OFF;
    }
    
  //end your routines here, this code is for
  //calling old event hook
  mempnt=eventhook;
  mempnt-=4;
  (DWORD) fnc=*( (DWORD *) mempnt);
  if(fnc)
  	fnc(ev);
	return;
}
//used to get end of function, for function size
asm("endevent:");


